<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>AggregateStatsListener.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">protean-tests</a> &gt; <a href="index.source.html" class="el_package">io.gitlab.littlesaints.protean.analytics</a> &gt; <span class="el_source">AggregateStatsListener.java</span></div><h1>AggregateStatsListener.java</h1><pre class="source lang-java linenums">/*
 *                     protean-core
 *              Copyright (C) 2018 Varun Anand
 *
 * This file is part of protean-core.
 *
 * protean-core is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 *
 * protean-core is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see &lt;http://www.gnu.org/licenses/&gt;.
 */

package io.gitlab.littlesaints.protean.analytics;

import java.util.Arrays;
import java.util.Collection;
import java.util.concurrent.CopyOnWriteArrayList;

public final class AggregateStatsListener&lt;E&gt; implements StatsListener&lt;E&gt; {

    private final Collection&lt;StatsListener&lt;E&gt;&gt; listeners;

    public AggregateStatsListener(StatsListener&lt;E&gt;... listeners) {
<span class="nc" id="L32">        this(Arrays.asList(listeners));</span>
<span class="nc" id="L33">    }</span>

<span class="fc" id="L35">    public AggregateStatsListener(Collection&lt;StatsListener&lt;E&gt;&gt; listeners) {</span>
<span class="fc" id="L36">        this.listeners = new CopyOnWriteArrayList&lt;&gt;(listeners);</span>
<span class="fc" id="L37">    }</span>

    public void registerListener(StatsListener&lt;E&gt; listener) {
<span class="nc" id="L40">        this.listeners.add(listener);</span>
<span class="nc" id="L41">    }</span>

    @Override
    public void eventProcessed(String context, E event, String name, long startMillis, long endMillis) {
<span class="fc" id="L45">        listeners.forEach(l -&gt; l.eventProcessed(context, event, name, startMillis, endMillis));</span>
<span class="fc" id="L46">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.4.201905082037</span></div></body></html>